// Begin $Header: /cygdrive/c/src/usi/RCS/udacut.c,v 1.1 2002/10/17 14:30:54 PC3 Exp $
// UDA'Software 2002
// $Date: 2002/10/17 14:30:54 $
// $Revision: 1.1 $

/*

	Questo programma server per troncare una riga passata sullo
	standard input alla posizione desiderata.

*/

/*

  Copyright (C) 1988 Free Software Foundation, Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

// *******************************************************************
//____________________________________________________________________
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#define MAXBUFFER	16777216

int main (int argc, char **argv) {
  char		*psBuffer = (char*)malloc(MAXBUFFER);
  unsigned int	uiCutPosition = 0;

  if (argc < 2) {
    fprintf(stderr, "\nSintassi Errata. Manca il parametro che determina a quale carattere troncare\nla stringa passata sullo standard input.\n");

    return 1;
  }

  uiCutPosition = atoi(argv[1]);

  // Resetta il buffer
  memset(psBuffer, '\0', MAXBUFFER);

  // Legge dallo standard input
  fgets(psBuffer, MAXBUFFER, stdin);

  // Se cio' che ha letto e valido ed il parametro passato e'
  // compatibile, provvede a troncare la stringa.
  if (psBuffer && uiCutPosition >= 0 && uiCutPosition < strlen(psBuffer))
    psBuffer[strlen(psBuffer) - uiCutPosition - 1] = '\0';

  // Stampa la stringa troncata sullo standard output.
  printf("%s", psBuffer);

  return 0;
}

// *******************************************************************
//____________________________________________________________________
// End $Source: /cygdrive/c/src/usi/RCS/udacut.c,v $
